
 ;///////////////////////////////////////////////////////////////////////////////////
 ;//
 ;// Bytessence AMVConverter (c) 2007 Trutia Alexandru
 ;// RSAutoResize (c) 2004-2006 USCode
 ;// Version: 0.8
 ;//
 ;//
 ;///////////////////////////////////////////////////////////////////////////////////
 ;
 #Version = "0.8"  
 ;
 XIncludeFile "Inc\ErrorHandler.pbi"
 XIncludeFile "Inc\Lang.pbi"
 XIncludeFile "Inc\Resize.pbi"
 ;
 Structure AMVConv
  Input.s
  Output.s
  Resolution.b
  Quality.b
  FPS.b
  Volume.l
  CropU.l
  CropD.l
  CropL.l
  CropR.l
  PadU.l
  PadD.l
  PadL.l
  PadR.l
 EndStructure
 ;
 Structure LanguageFile
  Name.s
  Path.s
 EndStructure
 ;
 Structure BAMVCPrefs
  Logging.l
 EndStructure
 ;
 Global CurrentDir.s = GetPathPart(ProgramFilename())
 Global ConversionMutex.b = 0
 Global Stepnum = 0
 Global FFMPEG.s = CurrentDir+"Core\ffmpeg.exe"
 Global CurrentLanguage.s
 Global BP.BAMVCPrefs
 ;
 Global NewList AMVConvert.AMVConv()
 Global NewList LanguageFiles.LanguageFile() 
 ;
 CatchImage(0,?Icon_Add)
 CatchImage(1,?Icon_Delete)
 CatchImage(2,?Icon_Edit)
 CatchImage(3,?Icon_Up)
 CatchImage(4,?Icon_Down)
 CatchImage(5,?Icon_Help)
 CatchImage(6,?Icon_About)
 CatchImage(7,?Icon_Exit)
 CatchImage(8,?Icon_Start)
 CatchImage(9,?Icon_Stop)
 CatchImage(10,?Image_About)
 CatchImage(11,?Image_Cropping)
 CatchImage(12,?Image_Padding)
 CatchImage(13,?Image_Splash)

 ;{ Create/read settings file
 If FileSize(CurrentDir+"Config.ini") = -1
  If CreatePreferences(CurrentDir+"Config.ini")
   PreferenceGroup("BAMVC")
   WritePreferenceString("Res","0")
   WritePreferenceString("Qual","0")
   WritePreferenceString("Frame","0")
   WritePreferenceString("Volume","8")
   WritePreferenceString("CropU","0")
   WritePreferenceString("CropD","0")
   WritePreferenceString("CropL","0")
   WritePreferenceString("CropR","0")
   WritePreferenceString("PadU","0")
   WritePreferenceString("PadD","0")
   WritePreferenceString("PadL","0")
   WritePreferenceString("PadR","0")
   PreferenceGroup("SET")
   WritePreferenceString("Language","")
   WritePreferenceString("LogActions","1")
   BP\Logging = 1
   ClosePreferences()
  EndIf
 Else
  If OpenPreferences(CurrentDir+"Config.ini")
   PreferenceGroup("SET")
   NeededLanguage.s = ReadPreferenceString("Language","")
   BP\Logging = Val(ReadPreferenceString("LogActions","1"))
   ClosePreferences()
  EndIf
 EndIf
 ;}
 
 ;{ Query languages
 If ExamineDirectory(0, CurrentDir+"Lang\", "*.ini")  
  While NextDirectoryEntry(0)
   If DirectoryEntryType(0) = #PB_DirectoryEntry_File
    LangFile.s = CurrentDir+"Lang\"+DirectoryEntryName(0)
    If Trim(LangFile) <> ""
     If OpenPreferences(LangFile)
      PreferenceGroup("BAMVCL")
      Name.s = ReadPreferenceString("Name","")
      ClosePreferences()
      If Name <> ""
       AddElement(LanguageFiles())
       LanguageFiles()\Name = Name
       LanguageFiles()\Path = LangFile
      EndIf
     EndIf
    EndIf
   EndIf
  Wend
  FinishDirectory(0)
 Else
  MessageRequester("Error","Error querying the languages directory!",#MB_ICONSTOP)
  End
 EndIf
;}
 
 ;{ Load language
  LoadLanguage(NeededLanguage)
  If OpenPreferences(NeededLanguage)
   PreferenceGroup("BAMVCL")
   CurrentLanguage.s = ReadPreferenceString("Name","")
   ClosePreferences()
  Else
   CurrentLanguage = "English"
  EndIf
 ;}

 If FileSize(FFMPEG) = -1 Or FileSize(FFMPEG) = 0 Or FileSize(FFMPEG) = -2
  MessageRequester(Language("Data", "s1"),Language("Data", "s2"),#MB_ICONSTOP)
  End
 EndIf
 
 ;-----------------------------------------------------
 
 Procedure Timer(Time.l)
 
  Repeat
   Delay(1000)
   Seconds + 1
  Until Time = Seconds
  ProcedureReturn 1
 
 EndProcedure
 
 ;-----------------------------------------------------
 
 Procedure SetToolbarItemText(Toolbar.l, TolbarItem.l, Text.s)
  Protected i.l, hdc.l, hToolbar.l, ButtonInfo.TBBUTTONINFO, Size.SIZE
  Static *FakeButtonStrings
  If *FakeButtonStrings = #Null
    *FakeButtonStrings = AllocateMemory(256) ; should be enough [127 icons]
    If *FakeButtonStrings
      For i = 0 To 254 Step 2
        PokeB(*FakeButtonStrings + i, 32)
      Next
    EndIf
  EndIf
  hToolbar = ToolBarID(Toolbar)
  If hToolbar
    ButtonInfo\cbSize = SizeOf(TBBUTTONINFO)
    ButtonInfo\dwMask = #TBIF_TEXT | #TBIF_COMMAND |#TBIF_SIZE
    ButtonInfo\pszText = @Text
    ButtonInfo\idCommand = TolbarItem
    hdc = GetDC_(hToolbar)
    If hdc
      GetTextExtentPoint32_(hdc, Text, Len(Text), @Size)
      ReleaseDC_(hToolbar, hdc)
      ButtonInfo\cx = Size\cx + 4
    EndIf
    If *FakeButtonStrings
      SendMessage_(hToolbar, #TB_ADDSTRING, 0, *FakeButtonStrings)
    EndIf
    SendMessage_(hToolbar, #TB_SETBUTTONINFO, TolbarItem, @ButtonInfo)
    SendMessage_(hToolbar, #TB_AUTOSIZE, 0, 0)
  EndIf
 EndProcedure
 
 ;-----------------------------------------------------
 
 Procedure AboutWindow()
  
  DisableWindow(0,1)
  
  If OpenWindow(1, 322, 214, 381, 305, Language("Data", "s3"), #PB_Window_SystemMenu | #PB_Window_WindowCentered | #PB_Window_TitleBar | #PB_Window_Invisible, WindowID(0))
    If CreateGadgetList(WindowID(1))
      ;
      ImageGadget(100, 5, 10, 48, 48, ImageID(10))
      Frame3DGadget(101, 5, 115, 370, 185, "")
      ButtonGadget(102, 290, 10, 85, 20, Language("Data", "s4"))
      TextGadget(103, 60, 15, 220, 15, "Bytessence AMVConverter")
      TextGadget(104, 60, 35, 315, 15, "Copyright (c) 2007-2008 Trutia Alexandru")
      StringGadget(105, 10, 126, 360, 169, "", #PB_String_ReadOnly|#ES_MULTILINE)
      HyperLinkGadget(106, 60, 60, 315, 15, "Homepage: http://www.bytessence.com", RGB(128, 128, 128))
      HyperLinkGadget(107, 60, 80, 315, 15, "AMV-Codec-Tools: http://code.google.com/p/amv-codec-tools/", RGB(128, 128, 128))
      HyperLinkGadget(108, 60, 100, 315, 15, "MyMpxPlayer: http://www.mympxplayer.org", RGB(128, 128, 128))
      ;
      SetGadgetColor(106,#PB_Gadget_FrontColor,RGB(65, 98, 190))
      SetGadgetColor(107,#PB_Gadget_FrontColor,RGB(65, 98, 190))
      SetGadgetColor(108,#PB_Gadget_FrontColor,RGB(65, 98, 190))
      ;
      SetGadgetText(105,PeekS(?CreditsS,?CreditsE-?CreditsS))
      ;
      HideWindow(1,0)
      ;
      Repeat
       ;
       Event = WaitWindowEvent()
       ;
       Select Event
        ;
        Case #PB_Event_Gadget
         ;
         Select EventGadget()
          ;
          Case 102 ;OK
           CloseWindow(1)
           DisableWindow(0,0)
           ProcedureReturn 1
          ;
          Case 106
           RunProgram("http://www.bytessence.com")
          ;
          Case 107
           RunProgram("http://code.google.com/p/amv-codec-tools/")
          ;
          Case 108
           RunProgram("http://www.mympxplayer.org")
          ;
         EndSelect
        ;
       EndSelect
       ;
      Until Event = #PB_Event_CloseWindow
      ;
      ;Return to the caller
      CloseWindow(1)
      DisableWindow(0,0)
      ProcedureReturn 1
      
    Else
     MessageRequester("Error","Could not create gadget list! Exiting.",#MB_ICONSTOP)
    EndIf
  Else
   MessageRequester("Error","Could not open main window! Exiting.",#MB_ICONSTOP)
  EndIf
  
 EndProcedure

 Procedure AddWindow(Type.b)
  
  If Type = 1
   State = GetGadgetState(50)
   If State = -1
    MessageRequester(Language("Data", "s1"),Language("Data", "s5"),#MB_ICONWARNING)
    ProcedureReturn 0
   Else
    OldInp.s = GetGadgetItemText(50,State,0)
    OldOut.s = GetGadgetItemText(50,State,1)
    ForEach AMVConvert()
     If AMVConvert()\Input = OldInp And AMVConvert()\Output = OldOut
      OldRes.b = AMVConvert()\Resolution
      OldQual.b = AMVConvert()\Quality
      OldFrame.b = AMVConvert()\FPS
      OldVolume = AMVConvert()\Volume
      OldCropU = AMVConvert()\CropU
      OldCropD = AMVConvert()\CropD
      OldCropL = AMVConvert()\CropL
      OldCropR = AMVConvert()\CropR
      OldPadU = AMVConvert()\PadU
      OldPadD = AMVConvert()\PadD
      OldPadL = AMVConvert()\PadL
      OldPadR = AMVConvert()\PadR
     EndIf
    Next
   EndIf
  EndIf
    
  DisableWindow(0,1)
  
  If OpenWindow(2, 393, 227, 402, 402, Language("Data", "s6"), #PB_Window_SystemMenu | #PB_Window_WindowCentered | #PB_Window_TitleBar | #PB_Window_Invisible, WindowID(0))
    ;
    If CreateGadgetList(WindowID(2))
      ButtonGadget(200, 220, 370, 85, 25, Language("Data", "s7"))
      ButtonGadget(201, 310, 370, 85, 25, Language("Data", "s8"))
      PanelGadget(202, 5, 5, 390, 360);>
      ; General information
      AddGadgetItem(202, -1, Language("Data", "s9"))
      Frame3DGadget(203, 5, 10, 375, 95, Language("Data", "s10"))
      TextGadget(204, 15, 38, 80, 15, Language("Data", "s11"))
      TextGadget(205, 15, 73, 80, 15, Language("Data", "s12"))
      StringGadget(206, 100, 35, 185, 20, "")
      StringGadget(207, 100, 70, 185, 20, "")
      ButtonGadget(208, 290, 32, 80, 25, Language("Data", "s13"))
      ButtonGadget(209, 290, 67, 80, 25, Language("Data", "s13"))
      Frame3DGadget(210, 5, 120, 375, 60, Language("Data", "s14"))
      ComboBoxGadget(211, 25, 145, 335, 100)
      Frame3DGadget(212, 5, 195, 375, 60, Language("Data", "s15"))
      ComboBoxGadget(213, 25, 220, 335, 100)
      Frame3DGadget(214, 5, 270, 375, 55, Language("Data", "s16"))
      ComboBoxGadget(215, 25, 290, 335, 100)
      ; Advanced options
      AddGadgetItem(202, -1, Language("Data", "s17"))
      Frame3DGadget(216, 5, 10, 375, 95, Language("Data", "s18"))
      TrackBarGadget(217, 20, 35, 340, 35, 0, 16, #PB_TrackBar_Ticks)
      TextGadget(218, 30, 75, 320, 20, Language("Data", "s19"))
      Frame3DGadget(219, 5, 115, 175, 140, Language("Data", "s20"))
      Frame3DGadget(220, 200, 115, 175, 140, Language("Data", "s21"))
      ImageGadget(221, 70, 165, 50, 50, ImageID(11))
      ImageGadget(222, 265, 165, 50, 50, ImageID(12))
      SpinGadget(223, 70, 220, 50, 20, 0, 25,#PB_Spin_ReadOnly|#PB_Spin_Numeric)
      SpinGadget(224, 125, 180, 50, 20, 0, 25,#PB_Spin_ReadOnly|#PB_Spin_Numeric)
      SpinGadget(225, 15, 180, 50, 20, 0, 25,#PB_Spin_ReadOnly|#PB_Spin_Numeric)
      SpinGadget(226, 70, 140, 50, 20, 0, 25,#PB_Spin_ReadOnly|#PB_Spin_Numeric)
      SpinGadget(227, 265, 140, 50, 20, 0, 25,#PB_Spin_ReadOnly|#PB_Spin_Numeric)
      SpinGadget(228, 210, 180, 50, 20, 0, 25,#PB_Spin_ReadOnly|#PB_Spin_Numeric)
      SpinGadget(229, 265, 220, 50, 20, 0, 25,#PB_Spin_ReadOnly|#PB_Spin_Numeric)
      SpinGadget(230, 320, 180, 50, 20, 0, 25,#PB_Spin_ReadOnly|#PB_Spin_Numeric)
      For N = 223 To 230
       SetGadgetText(N,"0")
      Next
      CloseGadgetList() ;<
      ;
      ;Add options
      AddGadgetItem(211,-1,"96 x 64"+" "+Language("Data", "s22"))
      AddGadgetItem(211,-1,"128 x 96"+" "+Language("Data", "s23"))
      AddGadgetItem(211,-1,"128 x 128"+" "+Language("Data", "s24"))
      AddGadgetItem(211,-1,"160 x 120"+" "+Language("Data", "s25"))
      AddGadgetItem(211,-1,"176 x 128"+" "+Language("Data", "s26"))
      AddGadgetItem(211,-1,"176 x 144"+" "+Language("Data", "s27"))
      AddGadgetItem(211,-1,"192 x 160"+" "+Language("Data", "s27"))
      AddGadgetItem(211,-1,"208 x 120"+" "+Language("Data", "s28"))
      AddGadgetItem(211,-1,"208 x 160"+" "+Language("Data", "s28"))
      AddGadgetItem(211,-1,"208 x 176"+" "+Language("Data", "s28"))
      ;
      AddGadgetItem(213,-1,Language("Data", "s29"))
      AddGadgetItem(213,-1,Language("Data", "s30"))
      AddGadgetItem(213,-1,Language("Data", "s31"))
      ;
      AddGadgetItem(215,-1,"10 FPS"+" "+Language("Data", "s32"))
      AddGadgetItem(215,-1,"12 FPS"+" "+Language("Data", "s33"))
      AddGadgetItem(215,-1,"16 FPS"+" "+Language("Data", "s34"))
      ;
      SetGadgetState(211,0)
      SetGadgetState(213,0)
      SetGadgetState(215,0)
      SetGadgetState(217,8)
      ;
      If Type = 1
       SetGadgetText(206,OldInp)
       SetGadgetText(207,OldOut)
       SetGadgetState(211,OldRes)
       SetGadgetState(213,OldQual)
       SetGadgetState(215,OldFrame)
       SetGadgetState(217,OldVolume)
       SetGadgetState(226,OldCropU)
       SetGadgetState(223,OldCropD)
       SetGadgetState(225,OldCropL)
       SetGadgetState(224,OldCropR)
       SetGadgetState(227,OldPadU)
       SetGadgetState(229,OldPadD)
       SetGadgetState(228,OldPadL)
       SetGadgetState(230,OldPadR)
      Else
       ;{ Read settings
       If OpenPreferences(GetPathPart(ProgramFilename())+"Config.ini")
        PreferenceGroup("BAMVC")
        SetGadgetState(211,Val(ReadPreferenceString("Res","0")))
        SetGadgetState(213,Val(ReadPreferenceString("Qual","0")))
        SetGadgetState(215,Val(ReadPreferenceString("Frame","0")))
        SetGadgetState(217,Val(ReadPreferenceString("Volume","0")))
        SetGadgetState(226,Val(ReadPreferenceString("CropU","0")))
        SetGadgetState(223,Val(ReadPreferenceString("CropD","0")))
        SetGadgetState(225,Val(ReadPreferenceString("CropL","0")))
        SetGadgetState(224,Val(ReadPreferenceString("CropR","0")))
        SetGadgetState(227,Val(ReadPreferenceString("PadU","0")))
        SetGadgetState(229,Val(ReadPreferenceString("PadD","0")))
        SetGadgetState(228,Val(ReadPreferenceString("PadL","0")))
        SetGadgetState(230,Val(ReadPreferenceString("PadR","0")))
        ClosePreferences()
        EndIf
       ;}
      EndIf
      ;
      HideWindow(2,0)
      ;
      Repeat
       Event = WaitWindowEvent()
       ;
       Select Event
        Case #PB_Event_Gadget
         Select EventGadget()
         
          Case 200 ;Cancel
           ;{ Save settings
           If OpenPreferences(GetPathPart(ProgramFilename())+"Config.ini")
            PreferenceGroup("BAMVC")
            WritePreferenceString("Res",Str(GetGadgetState(211)))
            WritePreferenceString("Qual",Str(GetGadgetState(213)))
            WritePreferenceString("Frame",Str(GetGadgetState(215)))
            WritePreferenceString("Volume",Str(GetGadgetState(217)))
            WritePreferenceString("CropU",Str(GetGadgetState(226)))
            WritePreferenceString("CropD",Str(GetGadgetState(223)))
            WritePreferenceString("CropL",Str(GetGadgetState(225)))
            WritePreferenceString("CropR",Str(GetGadgetState(224)))
            WritePreferenceString("PadU",Str(GetGadgetState(227)))
            WritePreferenceString("PadD",Str(GetGadgetState(229)))
            WritePreferenceString("PadL",Str(GetGadgetState(228)))
            WritePreferenceString("PadR",Str(GetGadgetState(230)))
            ClosePreferences()
           EndIf
           ;}
           CloseWindow(2)
           DisableWindow(0,0)
           ProcedureReturn 1
           
          Case 201 ;Accept
           ;{ Save settings
           If OpenPreferences(GetPathPart(ProgramFilename())+"Config.ini")
            PreferenceGroup("BAMVC")
            WritePreferenceString("Res",Str(GetGadgetState(211)))
            WritePreferenceString("Qual",Str(GetGadgetState(213)))
            WritePreferenceString("Frame",Str(GetGadgetState(215)))
            WritePreferenceString("Volume",Str(GetGadgetState(217)))
            WritePreferenceString("CropU",Str(GetGadgetState(226)))
            WritePreferenceString("CropD",Str(GetGadgetState(223)))
            WritePreferenceString("CropL",Str(GetGadgetState(225)))
            WritePreferenceString("CropR",Str(GetGadgetState(224)))
            WritePreferenceString("PadU",Str(GetGadgetState(227)))
            WritePreferenceString("PadD",Str(GetGadgetState(229)))
            WritePreferenceString("PadL",Str(GetGadgetState(228)))
            WritePreferenceString("PadR",Str(GetGadgetState(230)))
            ClosePreferences()
           EndIf
           ;}
           InFile.s = Trim(GetGadgetText(206))
           OutFile.s = Trim(GetGadgetText(207))
           If InFile <> ""
            If OutFile <> ""
             If FileSize(InFile) <> -1 And FileSize(InFile) <> 0
              If Type = 0
               AddElement(AMVConvert())
               AMVConvert()\Input = InFile
               AMVConvert()\Output = OutFile
               AMVConvert()\Resolution = GetGadgetState(211)
               AMVConvert()\Quality = GetGadgetState(213)
               AMVConvert()\FPS = GetGadgetState(215)
               AMVConvert()\Volume = GetGadgetState(217)
               AMVConvert()\CropU = GetGadgetState(226) ;Ctop
               AMVConvert()\CropD = GetGadgetState(223) ;Cbottom
               AMVConvert()\CropL = GetGadgetState(225) ;Cleft
               AMVConvert()\CropR = GetGadgetState(224) ;Cright
               AMVConvert()\PadU = GetGadgetState(227) ;Ptop
               AMVConvert()\PadD = GetGadgetState(229) ;Pbottom
               AMVConvert()\PadL = GetGadgetState(228) ;Pleft
               AMVConvert()\PadR = GetGadgetState(230) ;Pright
              Else
               ForEach AMVConvert()
                If AMVConvert()\Input = OldInp And AMVConvert()\Output = OldOut
                 AMVConvert()\Input = InFile
                 AMVConvert()\Output = OutFile
                 AMVConvert()\Resolution = GetGadgetState(211)
                 AMVConvert()\Quality = GetGadgetState(213)
                 AMVConvert()\FPS = GetGadgetState(215)
                 AMVConvert()\Volume = GetGadgetState(217)
                 AMVConvert()\CropU = GetGadgetState(226) ;Ctop
                 AMVConvert()\CropD = GetGadgetState(223) ;Cbottom
                 AMVConvert()\CropL = GetGadgetState(225) ;Cleft
                 AMVConvert()\CropR = GetGadgetState(224) ;Cright
                 AMVConvert()\PadU = GetGadgetState(227) ;Ptop
                 AMVConvert()\PadD = GetGadgetState(229) ;Pbottom
                 AMVConvert()\PadL = GetGadgetState(228) ;Pleft
                 AMVConvert()\PadR = GetGadgetState(230) ;Pright
                EndIf
               Next
              EndIf
              Select AMVConvert()\Resolution
               Case 0
                ResText.s = "96 x 64"
               Case 1
                ResText.s = "128 x 96"
               Case 2
                ResText.s = "128 x 128"
               Case 3
                ResText.s = "160 x 120"
               Case 4
                ResText.s = "176 x 128"
               Case 5
                ResText.s = "176 x 144"
               Case 6
                ResText.s = "192 x 160"
               Case 7
                ResText.s = "208 x 120"
               Case 8
                ResText.s = "208 x 160"
               Case 9
                ResText.s = "208 x 176"
              EndSelect
              Select AMVConvert()\Quality
               Case 0
                QualText.s = "High"
               Case 1
                QualText.s = "Medium"
               Case 2
                QualText.s = "Low"
              EndSelect
              Select AMVConvert()\FPS
               Case 0
                FPSText.s = "10 FPS"
               Case 1
                FPSText.s = "12 FPS"
               Case 2
                FPSText.s = "16 FPS"
              EndSelect
              If Type = 0
               AddGadgetItem(50,-1,AMVConvert()\Input+Chr(10)+AMVConvert()\Output+Chr(10)+ResText+Chr(10)+QualText+Chr(10)+"Waiting")
              Else
               SetGadgetItemText(50,State,AMVConvert()\Input,0)
               SetGadgetItemText(50,State,AMVConvert()\Output,1)
               SetGadgetItemText(50,State,ResText,2)
               SetGadgetItemText(50,State,QualText,3)
               SetGadgetItemText(50,State,Language("Data", "s35"),4)
              EndIf
              StatusBarText(0, 1, Str(CountGadgetItems(50))+ " "+Language("Data", "s36"))
              CloseWindow(2)
              DisableWindow(0,0)
              ProcedureReturn 1
             Else
              MessageRequester(Language("Data", "s1"),Language("Data", "s37"),#MB_ICONWARNING)
             EndIf
            Else
             MessageRequester(Language("Data", "s1"),Language("Data", "s38"),#MB_ICONWARNING)
            EndIf
           Else
            MessageRequester(Language("Data", "s1"),Language("Data", "s39"),#MB_ICONWARNING)
           EndIf
          
          Case 217 ;Volume
           St = GetGadgetState(217)
           If St = 8
            SetGadgetText(218,Language("Data", "s40"))
           ElseIf St > 8
            SetGadgetText(218,Language("Data", "s41"))
           ElseIf St < 8
            SetGadgetText(218,Language("Data", "s42"))
           EndIf
          
          Case 208 ;Inp
           InputFile.s = OpenFileRequester(Language("Data", "s43"),"",Language("Data", "s44")+" (avi,flv,hdmov,mkv,mpg,m2v,mp4,nsv,nut,qt,mov,rm,smk,ogm,wmv,asf,3gp) |*.AVI; *.FLV; *.HDMOV; *.MKV; *.MJPG; *.MPG; *.M2V; *.MP4; *.M4V; *.NSV; *.NUT; *.QT; *.MOV; *.RM; *.SMK; *.OGM; *.WMV; *.ASF; *.3GP; *.3G2",0)
           If InputFile <> ""
            If FileSize(InputFile) > 0
             SetGadgetText(206,InputFile)
             SetGadgetText(207,ReplaceString(InputFile,GetExtensionPart(InputFile),"amv",1))
            EndIf
           EndIf
          
          Case 209 ;Out
           OutputFile.s = SaveFileRequester(Language("Data", "s45"),"","AMV (*.amv)|*.amv",0)
           If OutputFile <> ""
            If LCase(Right(OutputFile,4)) <> ".amv"
             OutputFile + ".amv"
            EndIf
            If FileSize(OutputFile) = -1 
             SetGadgetText(207,OutputFile)
            Else
             MessageRequester(Language("Data", "s1"),Language("Data", "s46"),#MB_ICONWARNING)
            EndIf
           EndIf
           
         EndSelect
       EndSelect
       ;
      Until Event = #PB_Event_CloseWindow
      
      ;Return to caller
      CloseWindow(2)
      DisableWindow(0,0)
      ProcedureReturn 1
      ;
    Else
     MessageRequester(Language("Data", "s1"),Language("Data", "s47"),#MB_ICONSTOP):End
    EndIf
  Else
   MessageRequester(Language("Data", "s1"),Language("Data", "s49"),#MB_ICONSTOP):End
  EndIf
  
 EndProcedure

 Procedure SplashWindow()

  TimerThread = CreateThread(@Timer(),3)

  If OpenWindow(3, 278, 248, 266, 200, "BAMVC initializing...",  #PB_Window_ScreenCentered | #PB_Window_BorderLess )
   If CreateGadgetList(WindowID(3))
    ImageGadget(300, 0, 0, 266, 200, ImageID(13))
   EndIf
  EndIf
  
  Repeat 
   Event = WaitWindowEvent(5)
   Delay(1)
  Until WaitThread(TimerThread,0)
  CloseWindow(3)
  ProcedureReturn 1
 
 EndProcedure

 Procedure SettingsWindow()
  
  DisableWindow(0,1)
  
  If OpenWindow(4, 403, 291, 315, 250, Language("Data", "s49"),  #PB_Window_WindowCentered | #PB_Window_TitleBar , WindowID(0))
   If CreateGadgetList(WindowID(4))
    TextGadget(400, 5, 10, 305, 15, Language("Data", "s50"))
    ListViewGadget(401, 5, 35, 305, 120)
    CheckBoxGadget(402, 5, 165, 275, 15, Language("Data", "s51"))
    ButtonGadget(404, 125, 215, 90, 30, Language("Data", "s7"))
    ButtonGadget(405, 220, 215, 90, 30, Language("Data", "s8"))
   EndIf
  EndIf
  
  ;Add all the languages there
  AddGadgetItem(401,-1,"English")
  ForEach LanguageFiles()
   AddGadgetItem(401,-1,LanguageFiles()\Name)
  Next
  SetGadgetState(402,BP\Logging)
  
  ;Select the current language in the list
  For Sel = 0 To CountGadgetItems(401)
   If LCase(CurrentLanguage) = LCase(GetGadgetItemText(401,Sel))
    SetGadgetState(401,Sel)
    Break
   EndIf
  Next

  Repeat
   Event = WaitWindowEvent()
   Select Event
    Case #PB_Event_Gadget
     Select EventGadget()
      Case 404 ;Cancel
       Event = #PB_Event_CloseWindow
      Case 405 ;OK
       LanguageState = GetGadgetState(401)
       If LanguageState <> -1
        LanguageName.s = GetGadgetItemText(401,LanguageState)
        If LCase(LanguageName) = "english" ;default,contained in exe
         LangToWrite.s = ""
        Else
         ForEach LanguageFiles()
          If LCase(LanguageFiles()\Name) = LCase(LanguageName)
           LangToWrite.s = LanguageFiles()\Path
           CurrentLanguage = LanguageFiles()\Name
           Break
          EndIf
         Next
        EndIf
        BP\Logging = GetGadgetState(402)
        If OpenPreferences(CurrentDir+"Config.ini")
         PreferenceGroup("SET")
         WritePreferenceString("Language",LangToWrite)
         WritePreferenceString("LogActions",Str(BP\Logging))
         ClosePreferences()
        EndIf
        Event = #PB_Event_CloseWindow
       Else
        MessageRequester("","Please select a language from the list.",#MB_ICONWARNING)
       EndIf
     EndSelect
   EndSelect
  Until Event = #PB_Event_CloseWindow
  CloseWindow(4)
  DisableWindow(0,0)
  ProcedureReturn 1
  
 EndProcedure

 ;----------------------------------------------------- 
 
 Procedure MoveUp()
 
  OldState = GetGadgetState(50)
  If OldState = -1
   MessageRequester(Language("Data", "s1"),Language("Data", "s53"),#MB_ICONWARNING)
   ProcedureReturn 0
  Else
   If CountGadgetItems(50) >= 2
    If OldState >= 1
     NewState = OldState-1
     OldInp.s = GetGadgetItemText(50,OldState,0)
     OldOut.s = GetGadgetItemText(50,OldState,1)
     OldRes.s = GetGadgetItemText(50,OldState,2)
     OldQual.s = GetGadgetItemText(50,OldState,3)
     OldStat.s = GetGadgetItemText(50,OldState,4)
     ResetList(AMVConvert())
     SelectElement(AMVConvert(),OldState)
     *First = @AMVConvert()
     SelectElement(AMVConvert(),NewState)
     *Second = @AMVConvert()
     SwapElements(AMVConvert(),*First,*Second)
     RemoveGadgetItem(50,OldState)
     AddGadgetItem(50,NewState,OldInp+Chr(10)+OldOut+Chr(10)+OldRes+Chr(10)+OldQual+Chr(10)+OldStat)
    Else
     ProcedureReturn 0
    EndIf
   Else
    ProcedureReturn 0
   EndIf
   ProcedureReturn 1
  EndIf
 
 EndProcedure
 
 Procedure MoveDown()
 
  OldState = GetGadgetState(50)
  If OldState = -1
   MessageRequester(Language("Data", "s1"),Language("Data", "s54"),#MB_ICONWARNING)
   ProcedureReturn 0
  Else
   If CountGadgetItems(50) >= 2
    If OldState+1 < CountGadgetItems(50)
     NewState = OldState+1
     OldInp.s = GetGadgetItemText(50,OldState,0)
     OldOut.s = GetGadgetItemText(50,OldState,1)
     OldRes.s = GetGadgetItemText(50,OldState,2)
     OldQual.s = GetGadgetItemText(50,OldState,3)
     OldStat.s = GetGadgetItemText(50,OldState,4)
     ResetList(AMVConvert())
     SelectElement(AMVConvert(),OldState)
     *First = @AMVConvert()
     SelectElement(AMVConvert(),NewState)
     *Second = @AMVConvert()
     SwapElements(AMVConvert(),*First,*Second)
     RemoveGadgetItem(50,OldState)
     AddGadgetItem(50,NewState,OldInp+Chr(10)+OldOut+Chr(10)+OldRes+Chr(10)+OldQual+Chr(10)+OldStat)
    Else
     ProcedureReturn 0
    EndIf
   Else
    ProcedureReturn 0
   EndIf
   ProcedureReturn 1
  EndIf
 
 EndProcedure
 
 Procedure Remove()
 
  State = GetGadgetState(50)
  If State = -1
   MessageRequester(Language("Data", "s1"),Language("Data", "s55"),#MB_ICONWARNING)
   ProcedureReturn 0
  Else
   ResetList(AMVConvert())
   SelectElement(AMVConvert(),State)
   DeleteElement(AMVConvert())
   RemoveGadgetItem(50,State)
   StatusBarText(0, 1, Str(CountGadgetItems(50)+1)+ " "+Language("Data", "s36"))
   ProcedureReturn 1
  EndIf
 
 EndProcedure
 
 ;----------------------------------------------------- 
 
 Procedure AddStatusLine(hLine.s)
  ;
  If BP\Logging = 1
   AddGadgetItem(51, -1, hLine)
   SetGadgetState(51, Stepnum)
   Stepnum = Stepnum + 1 
  EndIf
  ;
 EndProcedure
 
 Procedure DisableGadgets(State)
 
  DisableToolBarButton(2,50,State)
  DisableToolBarButton(2,51,State)
  DisableToolBarButton(2,52,State)
  DisableToolBarButton(2,53,State)
  DisableToolBarButton(2,54,State)
  DisableToolBarButton(2,58,State)
  DisableToolBarButton(2,55,State)
  DisableToolBarButton(2,56,State)
  DisableToolBarButton(2,57,State)
  
  ProcedureReturn 1
 
 EndProcedure
 
 ;----------------------------------------------------- 
 
 Procedure StartConversion()

   ForEach AMVConvert()
    ;
    InputFile.s = "-i "+Chr(34) + AMVConvert()\Input + Chr(34)
    OutputFile.s = Chr(34) + AMVConvert()\Output + Chr(34)
    ;
    AudioText.s = "-ac 1 -ar 22050 "
    FmtText.s = "-f amv "
    ;
    Select AMVConvert()\Resolution
     Case 0
      ResText.s = "-s 96x64 "
     Case 1
      ResText.s = "-s 128x96 "
     Case 2
      ResText.s = "-s 128x128 "
     Case 3
      ResText.s = "-s 160x120 "
     Case 4
      ResText.s = "-s 176x128 "
     Case 5
      ResText.s = "-s 176x144 "
     Case 6
      ResText.s = "-s 192x160 "
     Case 7
      ResText.s = "-s 208x120 "
     Case 8
      ResText.s = "-s 208x160 "
     Case 9
      ResText.s = "-s 208x176 "
    EndSelect
    Select AMVConvert()\Quality
     Case 0
      QualText.s = "-qmin 3 -qmax 4 " ;High
     Case 1
      QualText.s = "-qmin 3 -qmax 5 " ;Medium
     Case 2
      QualText.s = "-qmin 5 -qmax 6 " ;Low
    EndSelect
    Select AMVConvert()\FPS
     Case 0
      FPSText.s = "-r 10 "
     Case 1
      FPSText.s = "-r 12 "
     Case 2
      FPSText.s = "-r 16 "
    EndSelect
    Select AMVConvert()\Volume
     Case 0
      VolText.s = " -vol 1"
     Case 1
      VolText.s = " -vol 2"
     Case 2
      VolText.s = " -vol 4"
     Case 3
      VolText.s = " -vol 8"
     Case 4
      VolText.s = " -vol 16"
     Case 5
      VolText.s = " -vol 32"
     Case 6
      VolText.s = " -vol 64"
     Case 7
      VolText.s = " -vol 128"
     Case 8
      VolText.s = " -vol 256"
     Case 9
      VolText.s = " -vol 384"
     Case 10
      VolText.s = " -vol 512"
     Case 11
      VolText.s = " -vol 768"
     Case 12
      VolText.s = " -vol 1024"
     Case 13
      VolText.s = " -vol 1280"
     Case 14
      VolText.s = " -vol 1536"
     Case 15
      VolText.s = " -vol 1792"
     Case 16
      VolText.s = " -vol 2048"
    EndSelect
    CropText.s = " -croptop "+Str(AMVConvert()\CropU)+" -cropbottom "+Str(AMVConvert()\CropD)+" -cropleft "+Str(AMVConvert()\CropL)+" -cropright "+Str(AMVConvert()\CropR)+" "
    PadText.s = " -padtop "+Str(AMVConvert()\PadU)+" -padbottom "+Str(AMVConvert()\PadD)+" -padleft "+Str(AMVConvert()\PadL)+" -padright "+Str(AMVConvert()\PadR)+" "
    ;
    CmdLine.s = InputFile+VolText+CropText+PadText+FmtText+ResText+FPSText+AudioText+QualText+OutputFile
    AddStatusLine("FFMpeg -> "+CmdLine)
    AddStatusLine("* FFMpeg(R) *")
    FFHandle = RunProgram(FFMPEG,CmdLine,"",#PB_Program_Error|#PB_Program_Open|#PB_Program_Hide)
    If FFHandle = 0
     MessageRequester(Language("Data", "s1"),Language("Data", "s56"),#MB_ICONSTOP)
     End
    EndIf
    ;
    For Seek = 1 To CountGadgetItems(50)
     ItemInp.s = GetGadgetItemText(50,Seek-1,0)
     ItemOut.s = GetGadgetItemText(50,Seek-1,1)
     If ItemInp = AMVConvert()\Input And ItemOut = AMVConvert()\Output
      ItemNeed = Seek - 1
      Break
     EndIf
    Next
    ;
    While ProgramRunning(FFHandle)
     ;Now we are looping here, in this procedure. The window needs to be refreshed,
     ;and since the other refresh and even handler code is down there, we need to
     ;do it here (as long as the launched FFmpeg runs). We need to do this so we can
     ;also see if the user presses the "stop conversion" button.
     Event = WaitWindowEvent(50) ;50 milliseconds for the timeout. if nothing happends in this interval, we just carry the jobs As usually
     RS_Resize(Event,0)
     If Event
      Select Event
       Case #PB_Event_Menu
        Select EventMenu()
         Case 59
          Question = MessageRequester(Language("Data", "s57"),Language("Data", "s58"),#MB_YESNO|#MB_ICONQUESTION)
          If Question = #PB_MessageRequester_Yes ;Stop
           KillProgram(FFHandle)
           CloseProgram(FFHandle)
           SetGadgetItemText(50,ItemNeed,Language("Data", "s35"),4)
           StatusBarText(0, 1, Str(CountGadgetItems(50))+ " "+Language("Data", "s36"))
           StatusBarText(0, 0, Language("Data", "s59"))
           ProcedureReturn 0
          EndIf
        EndSelect
      EndSelect
     EndIf
     ;
     Err.s = Trim(ReadProgramError(FFHandle))
     If Err <> ""
      ;
      AddStatusLine("FFMpeg -> "+Err)
      ;
      If FindString(Err,"Duration:",0) And FindString(Err,"start:",0) And FindString(Err,"bitrate:",0)
       TimeStr.s = Trim(RemoveString(StringField(Err,1,","),"Duration: ",1))
       Hours.f = ValF(StringField(TimeStr,1,":"))
       Minutes.f = ValF(StringField(TimeStr,2,":"))
       Seconds.f = ValF(StringField(TimeStr,3,":"))
       TotalSeconds.f = Seconds + (Minutes * 60) + (Hours * 3600)
      ElseIf FindString(Err,"frame=",0) And FindString(Err,"fps=",0) And FindString(Err,"time=",0) And FindString(Err,"bitrate=",0)
       TmpString.s = Mid(Err,FindString(Err,"time=",0)+Len("time="),Len(Err))
       PassedSeconds.f = ValF(Trim(StringField(TmpString,1,"bitrate=")))
      EndIf
      If TotalSeconds <> -1 And TotalSeconds <> -1
       Progress.f = (PassedSeconds / TotalSeconds) * 100
       If Progress >= 0
        SetGadgetItemText(50,ItemNeed,StrF(Progress,1)+"% ready",4)
       EndIf
      EndIf
     EndIf
    Wend
    ;
    ErrCode.l = ProgramExitCode(FFHandle)
    If ErrCode <> 0
     SetGadgetItemText(50,ItemNeed,Language("Data", "s60")+" "+Str(ErrCode),4)
     OneFailed + 1
    Else
     SetGadgetItemText(50,ItemNeed,Language("Data", "s61"),4)
    EndIf
    If IsProgram(FFHandle)
     KillProgram(FFHandle)
     CloseProgram(FFHandle)
    EndIf
    ;
   Next
   ;
   If OneFailed = 0
    MessageRequester(Language("Data", "s109"),Language("Data", "s62"),#MB_ICONINFORMATION)
   Else
    MessageRequester(Language("Data", "s1"),Language("Data", "s63"),#MB_ICONINFORMATION)
   EndIf
   ProcedureReturn 1
 
 EndProcedure

 ;-----------------------------------------------------
 
 If OpenWindow(0, 0, 0, 600, 450, "Bytessence AMVConverter"+" "+#Version, #PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_SizeGadget|#PB_Window_Invisible|#PB_Window_ScreenCentered)
 
  If CreateGadgetList(WindowID(0))
   
   ;{ The status-bar
   
   StatusBar = CreateStatusBar(0,WindowID(0))
   If StatusBar
    AddStatusBarField(90)
    AddStatusBarField(100)
    StatusBarText(0, 0, Language("Data", "s64"))
    StatusBarText(0, 1, Language("Data", "s65"))
   EndIf
   
   ;}
  
   ;{ The menus
   
    If CreateMenu(1,WindowID(0))
    
     MenuTitle(Language("Data", "s66"))
     MenuItem(0, Language("Data", "s67")  +Chr(9)+"Ctrl+A")
     MenuItem(1, Language("Data", "s68")  +Chr(9)+"Ctrl+R")
     MenuBar()
     MenuItem(2, Language("Data", "s69")  +Chr(9)+"Alt+F4")
    
     MenuTitle(Language("Data", "s70"))
     MenuItem(3, Language("Data", "s71"))
     MenuItem(4, Language("Data", "s72"))
     MenuItem(5, Language("Data", "s73"))
    
     MenuTitle(Language("Data", "s74"))
     MenuItem(9, Language("Data", "s75"))
     MenuItem(10, Language("Data", "s76"))
     
     MenuTitle(Language("Data", "s77"))
     MenuItem(11,Language("Data", "s78"))
    
     MenuTitle(Language("Data", "s79"))
     MenuItem(6, Language("Data", "s80")  +Chr(9)+"F1")
     MenuBar()
     MenuItem(7, Language("Data", "s81"))
     MenuItem(8, Language("Data", "s82"))
    
    EndIf 

   ;}
   
   ;{ The toolbar
     CreateToolBar(2, WindowID(0))
     ToolBarSeparator()
     ToolBarImageButton(50,ImageID(0))
     ToolBarImageButton(51,ImageID(1))
     ToolBarSeparator()
     ToolBarImageButton(52,ImageID(2))
     ToolBarImageButton(53,ImageID(3))
     ToolBarImageButton(54,ImageID(4))
     ToolBarSeparator()
     ToolBarImageButton(58,ImageID(5))
     ToolBarImageButton(59,ImageID(6))
     ToolBarSeparator()
     ToolBarImageButton(55,ImageID(7))
     ToolBarImageButton(56,ImageID(8))
     ToolBarImageButton(57,ImageID(9))
   
     SetToolbarItemText(2,50,Language("Data", "s83"))
     SetToolbarItemText(2,51,Language("Data", "s84"))
     SetToolbarItemText(2,52,Language("Data", "s85"))
     SetToolbarItemText(2,53,Language("Data", "s86"))
     SetToolbarItemText(2,54,Language("Data", "s87"))
     SetToolbarItemText(2,58,Language("Data", "s88"))
     SetToolbarItemText(2,59,Language("Data", "s89"))
     SetToolbarItemText(2,55,Language("Data", "s90"))
     SetToolbarItemText(2,56,Language("Data", "s91"))
     SetToolbarItemText(2,57,Language("Data", "s92"))
   ;}
    
   ;{ The gadgets (controls)
    ListIconGadget(50, 0, 30, 600, 275, Language("Data", "s93"), 150, #PB_ListIcon_GridLines|#PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)
    AddGadgetColumn(50,1,Language("Data", "s94"),150)
    AddGadgetColumn(50,2,Language("Data", "s95"),100)
    AddGadgetColumn(50,3,Language("Data", "s96"),100)
    AddGadgetColumn(50,4,Language("Data", "s97"),95)
    ListViewGadget(51, 0, 300, 100, 50)
    SplitterGadget(52, 0, 45, 600, 366, 50, 51)
    SetGadgetState(52,300)
    RS_Register(0,52, 1, 1, 1, 1)
   ;}

   ;{ Shortcuts
    AddKeyboardShortcut(0,#PB_Shortcut_F1,6)
    AddKeyboardShortcut(0,#PB_Shortcut_Control|#PB_Shortcut_A,0)
    AddKeyboardShortcut(0,#PB_Shortcut_Control|#PB_Shortcut_R,1)
    AddKeyboardShortcut(0,#PB_Shortcut_Delete,1)
   ;}
   
   ;{ Resize the listicon
    Dim sbFields(1) ;Array that will help us resize the header
    WinWidth = WindowWidth(0)
    WinHeight = WindowWidth(0)
    For Res = 1 To 5
     SetGadgetItemAttribute(50, 0, #PB_ListIcon_ColumnWidth, WinWidth/5-1, Res-1)
    Next
  ;}
   
   ;{ Show the window and enter the event loop
    If SplashWindow()
     HideWindow(0,0)
     AddStatusLine("Bytessence AMVConverter"+" "+#Version+" "+Language("Data", "s98"))
     AddStatusLine(Language("Data", "s99"))
    EndIf
   ;}
   
  Else
   MessageRequester(Language("Data", "s1"),Language("Data", "s47"),#MB_ICONSTOP):End
  EndIf
  
  ;{ Resize the listicon
  Dim sbFields(1) ;Array that will help us resize the header
  WinWidth = WindowWidth(0)
  WinHeight = WindowWidth(0)
  For Res = 1 To 5
   SetGadgetItemAttribute(50, 0, #PB_ListIcon_ColumnWidth, WinWidth/5-1, Res-1)
  Next
  ;}
  
  Repeat
  
   Event = WaitWindowEvent()
   RS_Resize(Event,0)

   Select Event
    ;
    Case #PB_Event_Menu ;{
     
     Select EventMenu()
      
      Case 0,50
       AddWindow(0)
      
      Case 1,51
       Remove()
      
      Case 2,57
       Question = MessageRequester(Language("Data", "s57"),Language("Data", "s100"),#MB_ICONQUESTION|#MB_YESNO)
       If Question = #PB_MessageRequester_Yes
        Quit = 1
       EndIf
      
      Case 3,52
       AddWindow(1)
      
      Case 4,53
       MoveUp()
      
      Case 5,54
       MoveDown()
      
      Case 6,55
       RunProgram(GetCurrentDirectory()+"BAMVC.html")
      
      Case 7
       RunProgram("http://www.bytessence.com")
      
      Case 8,56
       AboutWindow()
      
      Case 9
       Count = CountGadgetItems(51)
       If Count > 0
        FileLog.s = SaveFileRequester(Language("Data", "s101"),"","Text (*.txt)|*.txt",0)
        If FileLog <> ""
         If Right(FileLog,4) <> ".txt"
          FileLog+".txt"
         EndIf
         If CreateFile(0,FileLog)
          For LS = 0 To CountGadgetItems(51)
           WriteStringN(0,GetGadgetItemText(51,LS))
          Next
          CloseFile(0)
         Else
          MessageRequester(Language("Data", "s1"),Language("Data", "s102"),#MB_ICONSTOP)
         EndIf
        EndIf
       Else
        MessageRequester(Language("Data", "s1"),Language("Data", "s103"),#MB_ICONWARNING)
       EndIf
      
      Case 10
       ClearGadgetItemList(51)
      
      Case 11
       SettingsWindow()
      
      Case 58
       If CountList(AMVConvert()) > 0
        If ConversionMutex = 0
         StatusBarText(0, 0, Language("Data", "s104"))
         AddStatusLine(Language("Data", "s104"))
         DisableGadgets(1)
         ConversionMutex = 1
         StartConversion()
         ConversionMutex = 0
         StatusBarText(0, 0, Language("Data", "s105"))
         AddStatusLine(Language("Data", "s105"))
         DisableGadgets(0)
        EndIf
       Else
        MessageRequester(Language("Data", "s106"),Language("Data", "s107"),#MB_ICONWARNING)
       EndIf
     
     EndSelect ;}

    Case #PB_Event_SizeWindow ;{
     WinWidth = WindowWidth(0)
     WinHeight = WindowWidth(0)
     sbFields(0) = WinWidth/2
     sbFields(1) = WinWidth
     SendMessage_(StatusBar, #SB_SETPARTS, 2, sbFields()) 
     For Res = 1 To 5
      SetGadgetItemAttribute(50, 0, #PB_ListIcon_ColumnWidth, WinWidth/5-1, Res-1)
     Next
     InvalidateRect_(GadgetID(50),0,1) ;}

    Case #PB_Event_CloseWindow ;{
     Question = MessageRequester("Please confirm","Are you sure you want to quit Bytessence AMVConverter?",#MB_ICONQUESTION|#MB_YESNO)
     If Question = #PB_MessageRequester_Yes
      Quit = 1 
     EndIf ;}
     
   EndSelect
   
  Until Quit = 1
  
 Else
  MessageRequester(Language("Data", "s1"),Language("Data", "s48"),#MB_ICONSTOP):End
 EndIf
 
 DataSection ;{ This is the resource table
  Icon_Add:
   IncludeBinary "DataSection\add.ico"
  Icon_Delete:
   IncludeBinary "DataSection\delete.ico"
  Icon_Edit:
   IncludeBinary "DataSection\edit.ico"
  Icon_Up:
   IncludeBinary "DataSection\up.ico"
  Icon_Down:
   IncludeBinary "DataSection\down.ico"
  Icon_Help:
   IncludeBinary "DataSection\help.ico"
  Icon_About:
   IncludeBinary "DataSection\about.ico"
  Icon_Exit:
   IncludeBinary "DataSection\exit.ico"
  Icon_Start:
   IncludeBinary "DataSection\start.ico"
  Icon_Stop:
   IncludeBinary "DataSection\stop.ico"
  Image_About:
   IncludeBinary "DataSection\BAMVC48.ico"
  Image_Cropping:
   IncludeBinary "DataSection\Cropping.bmp"
  Image_Padding:
   IncludeBinary "DataSection\Padding.bmp"
  Image_Splash:
   IncludeBinary "DataSection\StartupLogo.bmp"
   
  CreditsS:
   IncludeBinary "DataSection\Credits.txt"
  CreditsE:
  
  ;=================================================
  
  ;This is the default language file
  Language:

    Data$ "_GROUP_",            "Data"
      Data$ "s1",               "Error"
      Data$ "s2",               "FFmpeg needs to exist in the ./Core directory. Please copy it there and restart the converter."
      Data$ "s3",               "About"
      Data$ "s4",               "Close"
      Data$ "s5",               "Please select (click) a task in the list in order to edit it's conversion configuration."
      Data$ "s6",               "Add video file"
      Data$ "s7",               "Cancel"
      Data$ "s8",               "Accept"
      Data$ "s9",               "General information"
      Data$ "s10",              "Input/Output files"
      Data$ "s11",              "Input:"
      Data$ "s12",              "Output:"
      Data$ "s13",              "Browse"
      Data$ "s14",              "Resolution"
      Data$ "s15",              "Quality"
      Data$ "s16",              "Frames per second"
      Data$ "s17",              "Advanced options"
      Data$ "s18",              "Adjust volume on the fly"
      Data$ "s19",              "Current: Not modified"
      Data$ "s20",              "Cropping (pixels)"
      Data$ "s21",              "Padding (pixels)"
      Data$ "s22",              "(1.0 inch screen)"
      Data$ "s23",              "(1.1 inch screen)"
      Data$ "s24",              "(1.2 inch screen)"
      Data$ "s25",              "(1.3 inch screen)"
      Data$ "s26",              "(1.5 inch screen)"
      Data$ "s27",              "(1.8 inch screen)"
      Data$ "s28",              "(2.0 inch screen)"
      Data$ "s29",              "High"
      Data$ "s30",              "Medium"
      Data$ "s31",              "Low"
      Data$ "s32",              "(recommended for 2 inch screen players)"
      Data$ "s33",              "(any display size)"
      Data$ "s34",              "(1.5 inch - 1.8 inch players)"
      Data$ "s35",              "Waiting"
      Data$ "s36",              "videos in the list."
      Data$ "s37",              "The input file is empty,inexistent or could not be accessed. Please check the path and try again."
      Data$ "s38",              "Please press 'Browse' to choose an output file."
      Data$ "s39",              "Please press 'Browse' to choose an input file."
      Data$ "s40",              "Current: Not modified"
      Data$ "s41",              "Current: Increased"
      Data$ "s42",              "Current: Decreased"
      Data$ "s43",              "Add media file"
      Data$ "s44",              "Supported video files"
      Data$ "s45",              "Save AMV file"
      Data$ "s46",              "The file already exists. Please choose another one."
      Data$ "s47",              "Could not create gadget list! Exiting."
      Data$ "s48",              "Could not open main window! Exiting."
      Data$ "s49",              "BAMVC Settings"
      Data$ "s50",              "Interface language (requires program restart)"
      Data$ "s51",              "Log actions"
      Data$ "s53",              "Please select (click) a task in the list in order to move it up."
      Data$ "s54",              "Please select (click) a task in the list in order to move it down."
      Data$ "s55",              "Please select (click) a task in the list in order to remove it."
      Data$ "s56",              "FFmpeg could not be spawned. Please check if it is present in the ./Core directory."
      Data$ "s57",              "Please confirm"
      Data$ "s58",              "Are you sure you want to cancel the current operation?"
      Data$ "s59",              "Conversion stopped by user..."
      Data$ "s60",              "FFmpeg error. Code"
      Data$ "s61",              "Converted!"
      Data$ "s62",              "Conversion finished successfully."
      Data$ "s63",              "Conversion finished with errors. Please check the log for details."
      Data$ "s64",              "Status: Please add some videos. For help press F1."
      Data$ "s65",              "No files in the list"
      Data$ "s66",              "File"
      Data$ "s67",              "Add video"
      Data$ "s68",              "Remove video"
      Data$ "s69",              "Exit"
      Data$ "s70",              "Edit"
      Data$ "s71",              "Edit task"
      Data$ "s72",              "Move task up"
      Data$ "s73",              "Move task down"
      Data$ "s74",              "Activity log"
      Data$ "s75",              "Save to file"
      Data$ "s76",              "Clear"
      Data$ "s77",              "Settings"
      Data$ "s78",              "Configure BAMVC"
      Data$ "s79",              "Help and Support"
      Data$ "s80",              "Contents"
      Data$ "s81",              "Visit our website"
      Data$ "s82",              "About"
      Data$ "s83",              "Add"
      Data$ "s84",              "Remove"
      Data$ "s85",              "Edit"
      Data$ "s86",              "Up"
      Data$ "s87",              "Down"
      Data$ "s88",              "Start"
      Data$ "s89",              "Stop"
      Data$ "s90",              "Help"
      Data$ "s91",              "About"
      Data$ "s92",              "Exit"
      Data$ "s93",              "Input file"
      Data$ "s94",              "Output file"
      Data$ "s95",              "Resolution"
      Data$ "s96",              "Quality"
      Data$ "s97",              "Status"
      Data$ "s98",              "initialized."
      Data$ "s99",              "Please press F1 for help."
      Data$ "s100",             "Are you sure you want to quit Bytessence AMVConverter?"
      Data$ "s101",             "Save log"
      Data$ "s102",             "The file could not be created!"
      Data$ "s103",             "The log is empty. There is nothing to be saved."
      Data$ "s104",             "Conversion in progress..."
      Data$ "s105",             "Conversion finished..."
      Data$ "s106",             "Sorry"
      Data$ "s107",             "You do not have any files to convert in the list. Use the 'Add' button to add videos to the list and then press 'Start conversion'. Press F1 to open the help file and find more info."
      Data$ "s108",             "Please select a language from the list."
      Data$ "s109",             "Success"
    Data$ "_END_",              ""
   
  LanguageEnd:
   
  ;=================================================
   
 EndDataSection ;}
 
 
 
; IDE Options = PureBasic 4.10 (Windows - x86)
; CursorPosition = 802
; FirstLine = 105
; Folding = AAAAA-
; EnableXP
; EnableOnError
; UseIcon = DataSection\BAMVC.ico
; Executable = BAMVC.exe
; CPU = 1
; CompileSourceDirectory
; DisableCompileCount = 52
; IncludeVersionInfo
; VersionField0 = 1.0.0.0
; VersionField1 = 1.0.0.0
; VersionField2 = Bytessence
; VersionField3 = Bytessence AMVConverter
; VersionField4 = 1.0.0.0
; VersionField5 = 1.0.0.0
; VersionField6 = Bytessence AMVConverter
; VersionField7 = BAMVC
; VersionField8 = BAMVC.exe
; VersionField9 = (c) 2007-2008 Trutia Alexandru
; VersionField13 = support@bytessence.com
; VersionField14 = www.bytessence.com
; VersionField16 = VFT_APP